''spr2bmp converter made by dreamerman
''it can also display DC maps
''For Dark Colony pc game
''project file spr2bmp.fdp - FbEdit - FB Code Editor
''
''compilation command: fbc -s console
''
''program commands:
''-p palette.bmp -> use color palette from file
''
''example use: spr2bmp trooper1.spr -p palette.bmp
''will output 'trooper1' directory with all .bmp files obtained from trooper1.spr file.

''start


''zmienna trzymajca info o rodzaju systemu
''win - windows, lin - linux, naley zmieni przy komiplacji pod Linuxem
#Define sys_op "win"

#If (sys_op = "win")
	#define WIN_INCLUDEALL
	#Include Once "windows.bi"
#Else
	Const NULL As Any Ptr = 0
#EndIf


#include "file.bi"
#Include "fbgfx.bi"
#Include "fbpng.bi"



Type Point_2d
	x As Integer
	y As Integer
End Type

Type tab_id
	id1 As Integer
	id2 As Integer
	is_id2 As UByte
End Type

Type typ_RGB
	r As UByte
	g As UByte
	b As UByte
End Type

Type Typ_opisu_animacji
	nazwa As String
	nr1 As Integer
	nr2 As Integer
End Type

Type Typ_opis_klatki
	plik_bazowy As String
	przes_x As Integer
	przes_y As Integer
	wielkosc_x As Integer
	wielkosc_y As Integer
	id_obrazka As Integer
	
End Type

Type Typ_opis_calej_animacji
	''panimacja As Typ_opisu_animacji Ptr
	''klatki_anim As Typ_opis_klatki Ptr
	panimacja(100) As Typ_opisu_animacji
	klatki_anim(600) As Typ_opis_klatki
	il_klatek As Integer
	il_panimacji As Integer
	nazwa_jednostki As String
	id_nazwa As String
	''aktualna animacja
	id_animacji As Integer
	nr_klatki As Integer	
End Type

Type Typ_obrazka_jednostki
	obrazek(500) As Any Ptr
	wielkosc_x(500) As Integer
	wielkosc_y(500) As Integer
	liczba_obrazkow As Integer
End Type

Type tablica_bajtow
	w1 As UByte
	w2 As UByte
	w3 As UByte
	w4 As UByte
End Type


''declare function png_save cdecl alias "png_save" ( byref filename as string, byval img as any ptr ) as integer



Declare Function Pobierz_komendy() As UByte
Declare Sub Petla_glowna()
Declare Sub Map_view()
Declare Sub Wczytaj_ustawienia()
Declare Sub Rozpisz_animacje()
Declare Sub Wczytaj_animacje_jednostki(ByRef wczyt_anim As Typ_opis_calej_animacji, ByVal obrazki_jedn As Typ_obrazka_jednostki, ByVal skrot_nazwa As String, ByVal lokalizacja As String)
Declare Sub Wczytaj_obrazki_animacji(ByRef obrazki_jedn As Typ_obrazka_jednostki, ByVal lokalizacja As String)
Declare Sub Tworz_spr()
Declare Function filebrowser (Byref ititle As String, Byref idir As String = Curdir) As String
Declare Sub Pobierz_wymiar(ByVal Plik_graficzny As String, ByRef Szer As UInteger, ByRef Wys As UInteger)
Declare Function Zwroc_plik (ByVal nazwapliku As String) As String


Dim Shared As String Plik_obrabiany, Plik_palety, Katalog_koncowka, Katalog_poczatek, Sam_plik, Plik_obciety
Dim Shared As UByte Uzywaj_palety = 0
Dim Shared As UByte Rodzaj_pliku = 0	''inaczej rodzaj rozszerzenia 0-spr, 1-bts
Dim Shared As String DC_path
Dim Shared As Point_2d ost_przes_obrazkow(500)	''ostatnie przesuniecia obrazkow
ReDim Shared As Ubyte Bajty_spr()	''bajty z pliku .spr


Print ".spr to .bmp converter for Dark Colony.. author: dreamerman" 



Dim As UByte ret1


ret1 = Pobierz_komendy()
Wczytaj_ustawienia()


If ret1 = 0 Then
	''converting graphic is in 32bits
	Screen 18, 32, 2, 0
	Petla_glowna()
ElseIf ret1 = 3 Then
	''map view is in 8bits
	Screen 18, 8, 2, 0
	Map_view()
ElseIf ret1 = 4 Then
	Screen 18, 32, 2, 0
	Rozpisz_animacje()
ElseIf ret1 = 5 Then
	Screen 18, 32, 2, 0
	Tworz_spr()
	''Test_boba()
EndIf
'/


''Screen 0
Print "Nacisnij dowolny klawisz."
Do While InKey$="":Sleep 10:Loop


End


Function Pobierz_komendy() As UByte
Dim As Integer Czi1, Czi2, Czi3, Czi4, Czi5, Czi6, Czi7, Czi8, Czi9	''z dedykacja dla Maranty :D
Dim As String czs1, czs2, czs3


Dim argc As Integer, argv As String, argn As Integer
argc = 1
Uzywaj_palety = 1
Plik_obrabiany = Command(1)
If Plik_obrabiany = "" Then
#If (sys_op = "win")
	Plik_obrabiany = filebrowser("Wybierz plik spr/bts", ExePath)
#ElseIf (sys_op = "lin")
	Input "Input .spr filename | Podaj nazwe pliku .spr: "; Plik_obrabiany
#EndIf
EndIf
''Print "plik: " & Plik_obrabiany
If Plik_obrabiany = "" Then Print "No input .spr file! | Nie podales pliku .spr!": Return 1
If Not FileExists(Plik_obrabiany) Then 
	If Not FileExists(ExePath & "/" & Plik_obrabiany) Then 
		Print "No file found! Nie ma takiego pliku!": Return 1
	Else
		Plik_obrabiany = ExePath & "/" & Plik_obrabiany
	EndIf
EndIf


Do
	argv = Command( argc )
	If( Len( argv ) = 0 ) Then
		Exit Do
	End If
	If argv = "-p" Then Uzywaj_palety = 2: Plik_palety = Command(argc + 1)
	''If argv = "-m" Then Rodzaj_pliku = 1	''dla plikow bts - grafika map
	If argv = "-r" Then Rodzaj_pliku = 3	''raw data
	argc += 1
Loop

'If Plik_palety = "" Then Input "Podaj palete: "; Plik_palety
'If Plik_palety<>"" Then Uzywaj_palety = 1
'If Uzywaj_palety =1 And Plik_palety = "" Then Print "No palette file typed! - Nie podales pliku z paleta!": Return 2

''najpierw trzeba ustalic poprawny katalog z, ktorego sa pobierane pliki bmp
czs1 = Plik_obrabiany
czi2 = 1: czi3 = 1
czi1 = InStr(czi2, czs1, "\")
Do While (czi1 > 0)
	czi4 = czi3
	czi3 = czi1
	czi2 = czi1 + 1
	czi1 = InStr(czi2, czs1, "\")
	''Print czi4 & " : " & czi3 & " : " & czi1
Loop
czs2 = Mid(czs1, czi4 + 1, czi3 - czi4 - 1)
czs1 = Left(czs1, czi2 - 1)
Print "katalog: '" & czs1 & "'"
Print "koncowka: '" & czs2 & "'"
Print "plik: '" & mid(Plik_obrabiany, czi2) & "'"
Katalog_koncowka = czs2
Katalog_poczatek = czs1
Sam_plik = mid(Plik_obrabiany, czi2)
Plik_obciety = Left(Sam_plik, Len(Sam_plik) - 4)
czs3 = czs2: czs2 = ""
''katalog ustalony
''Return 255

Select Case LCase(Right(Plik_obrabiany, 4))
	Case ".spr"	''normal spr file
		Rodzaj_pliku = 0
		'Uzywaj_palety = 1
	Case ".bts"	''map graphic
		Rodzaj_pliku = 1
		'Uzywaj_palety = 1
	Case ".map"
		Return 3
	Case ".fin"	''animation description
		Return 4
	Case ".png"	''bmp na spr
		Return 5
	Case ".trs"	''TRS na spr
		Rodzaj_pliku = 10
	Case ".trc"	''archiwa tric
		Rodzaj_pliku = 11
	Case ".trw"	''archiwa tric
		Rodzaj_pliku = 12
	Case Else
		If Not Rodzaj_pliku = 3 Then
			Return 255
			Print "Unrecognized file type!"
		EndIf
End Select

Return 0
	
End Function


Sub Petla_glowna()
''ReDim As Ubyte Bajty_spr()	''bajty z pliku .spr
Dim As LongInt Len_spr = 0	''dlugosc pliku .spr
Dim As LongInt Pwps, pwps2		''pozycja w pliku .spr
Dim As Integer Czi1, Czi2, Czi3, Czi4, Czi5, Czi6, Czi7	''z dedykacja dla Maranty :D
Dim As UByte Czub1, Czub2, Czub3
Dim As Integer Tab_palety(255)	''tablica z paleta colorow
Dim As Integer Tab_palety_org(255)	''oryginalna tablica z paleta
Dim As String czs1, czs2
Dim As UByte Typ_pliku = 0	''zwykly, skompresowany...
Dim As Integer Woda_anim_poz = 0	''do animacji wody ;]
Dim As UByte Centrowac_grafike = 0	''czy doklejac brakujace el tla - centrowanie grafiki
Dim As Integer Ilosc_obrazkow = 0
Dim As Integer max_szer, max_wys
Dim As UByte Png_czy_bmp = 0	''default to png
Dim As UByte last_buf_black, last_buf_normal, zawijac_czarne

Dim As UByte tab_pal_uzywana(255)

Len_spr = FileLen(Plik_obrabiany)
ReDim Bajty_spr(Len_spr-1)

Dim As Integer wp1, wp2, wp3

If Rodzaj_pliku = 0 Then
	Input "Centrowac grafike? (t/n) - jedynie DC"; czs1
	czs1 = Left(czs1, 1)
	If czs1 = "y" Or czs1 = "t" Then Centrowac_grafike = 1
EndIf
Input "Tworzyc png czy bmp";czs1
If InStr(czs1, "b")>0 Then Png_czy_bmp = 1


wp1 = FreeFile
Open Plik_obrabiany For Binary As wp1
Get #wp1, , Bajty_spr()
Close #wp1


''katalogi / pliki
czs1 = Left(Plik_obrabiany, Len(Plik_obrabiany)-4)
czs1 = Katalog_poczatek & Plik_obciety & "\"
If Len(czs1) > 200 Then czs1 = ExePath & "\" & "output\" 
If Not FileExists(czs1) Then MkDir czs1
''Print czs1 & "*.*"
''Kill ExePath & "\" & czs1 & "\*.*"

wp1 = FreeFile
Open czs1 & "build.txt" For Output As #wp1
Print #wp1, "''build file for bmp2spr converter, ver 30.04.2011"


''otwieranie palety
''If FileExists(ExePath & "\palette.bmp") Then Plik_palety = "palette.bmp": Uzywaj_palety = 2
Dim As Any Ptr Paletaimg	''jest uzywane pozniej wiec poza ifem
''testowe wczytywanie palety
Select Case As Const Uzywaj_palety
	Case 0	''inne pliki, paleta domyslna dla fb
	For czi1 = 0 To 255
		Palette Get czi1, Tab_palety(czi1)
		tab_palety_org(czi1) = tab_palety(czi1)
	Next czi1
	
	Case 1
	Dim As Any ptr Paletaimg2
	Paletaimg2 = ImageCreate(256, 1, 0, 32)
	pwps = 8
	For czi1 = 0 To 255
		czub1 = 4*Bajty_spr(pwps): If Not czub1=0 Then czub1+=3
		czub2 = 4*Bajty_spr(pwps+1): If Not czub2=0 Then czub2+=3
		czub3 = 4*Bajty_spr(pwps+2): If Not czub3=0 Then czub3+=3
		''If czub3=255 And czub1 = 235 Then czub1 = 255: czub2 = 0	''poprawka na rozowy dla dungli
		Tab_palety(czi1) = RGB(czub1, czub2, czub3)
		tab_palety_org(czi1) = tab_palety(czi1)
		pwps+=3
		pset Paletaimg2, (czi1, 0), RGB(czub1, czub2, czub3)
	Next czi1
	BSave czs1 & "palette.bmp",  Paletaimg2, 768
	''BSave ExePath & "\" & czs1 & "\" & Str(czi1) & ".bmp", Obrazek_teraz, Wielkosc_obrazka(czi1).x * Wielkosc_obrazka(czi1).y * 3
	ImageDestroy(Paletaimg2)
	
	Case 2	''wp1 = FreeFile
	Paletaimg = ImageCreate(256, 1, 0, 32)
	Dim ret As Integer
	ret = BLoad(ExePath & "\" & Plik_palety, Paletaimg)
	Print ret
	For czi1 = 0 To 255
		Tab_palety(czi1) = Point(czi1, 0, Paletaimg)
		tab_palety_org(czi1) = tab_palety(czi1)
	Next czi1
	BSave czs1 & "palette.bmp",  Paletaimg, 768
	ImageDestroy(Paletaimg)
End Select


Select Case As Const Rodzaj_pliku
	Case 1	''dla grafiki map
	Ilosc_obrazkow = Bajty_spr(5) * 256 + Bajty_spr(4)
	pwps = 776
	Typ_pliku = 0
	wp2 = FreeFile
	Open czs1 & Plik_obciety & ".txt" For Output As #wp2
	Print #wp1, "1"	''map id type for building spr
	Print #wp1, "0"	''not compressed

	If Not FileExists(czs1 & "1\") Then MkDir czs1 & "1\"
	If Not FileExists(czs1 & "2\") Then MkDir czs1 & "2\"
	If Not FileExists(czs1 & "3\") Then MkDir czs1 & "3\"
	If Not FileExists(czs1 & "4\") Then MkDir czs1 & "4\"
	If Not FileExists(czs1 & "5\") Then MkDir czs1 & "5\"
	If Not FileExists(czs1 & "6\") Then MkDir czs1 & "6\"
	If Not FileExists(czs1 & "7\") Then MkDir czs1 & "7\"
	
	Case 3	''raw data
	Input "number of images | liczba obrazkow: ", czs2
	Ilosc_obrazkow = Val(czs2)
	Typ_pliku = 0
	Print #wp1, "0"	''spr type
	Print #wp1, "0"	''not compressed
	
	Case 10, 11, 12	''pliki z Jurrasic War - trs (sprite), trc (archiwum), trw (wave?)
	pwps = 32
	Ilosc_obrazkow = Bajty_spr(9) * 256 + Bajty_spr(8)
	Typ_pliku = 0	''bez kompresji
	
	Case Else	''pliki spr
	Ilosc_obrazkow = Bajty_spr(3) * 256 + Bajty_spr(2)
	''Ilosc_obrazkow = Bajty_spr(2)
	If Bajty_spr(0) = 1 Then
		Typ_pliku = 0	''zwykly - 01 00
	Else
		Typ_pliku = 1	''skompresowany - 81 00
	EndIf
	pwps = 776
	Print #wp1, "0"	''spr type
	Print #wp1, Typ_pliku	''compressed or not
		
End Select
''Close #wp1

Dim As Point_2d Wielkosc_obrazka(Ilosc_obrazkow)
Dim As Point_2d Przes_obrazka(Ilosc_obrazkow)
Dim As String nazwa_pza(Ilosc_obrazkow)
Print "Naglowek: " & Bajty_spr(0) & " " & Bajty_spr(1)
Print "Obrazkow w pliku: " & Ilosc_obrazkow
Print "Wielkosc pliku: " & Len_spr

Select Case As Const Rodzaj_pliku
	Case 1	''dla grafiki map
	For czi1 = 1 To Ilosc_obrazkow
		Wielkosc_obrazka(czi1).x = 32
		Wielkosc_obrazka(czi1).y = 32
	Next czi1
	
	Case 3	''raw data
	Input "width | szerokosc: ", czs2
	czi2 = Val(czs2)
	Input "height | wysokosc: ", czs2
	czi3 = Val(czs2)
	For czi1 = 1 To Ilosc_obrazkow
		Wielkosc_obrazka(czi1).x = czi2
		Wielkosc_obrazka(czi1).y = czi3
	Next czi1
	pwps=0
	
	Case 10	''trs
	For czi1 = 1 To Ilosc_obrazkow
		Wielkosc_obrazka(czi1).x = Bajty_spr(pwps+5)*256 + Bajty_spr(pwps+4)
		Wielkosc_obrazka(czi1).y = Bajty_spr(pwps+7)*256 + Bajty_spr(pwps+6)
		pwps+=16
	Next czi1
	
	Case 11	''trc
	For czi1 = 1 To Ilosc_obrazkow
		nazwa_pza(czi1) = ""
		czi4 = 0
		For czi2 = 0 To 15
			czi3 = Bajty_spr(pwps+czi2)
			If czi3 = 0 And czi4 = 1 Then Exit For
			If czi3 = 46 Then czi4 = 1	''kropka juz byla
			If (czi3 > 47 And czi3 < 58) Or (czi3 > 64 And czi3 < 123) Or (czi3 = 32 Or czi3 = 46) Then
			nazwa_pza(czi1) = nazwa_pza(czi1) & Chr(Bajty_spr(pwps+czi2))
			EndIf
		Next czi2
		Wielkosc_obrazka(czi1).x = Bajty_spr(pwps+22)*65536 + Bajty_spr(pwps+21)*256 + Bajty_spr(pwps+20)
		Wielkosc_obrazka(czi1).y = 1
		pwps+=32
	Next czi1
	
	Case 12	''trw
	For czi1 = 1 To Ilosc_obrazkow
		nazwa_pza(czi1) = Str(czi1) & ""
		czi4 = 0
		Wielkosc_obrazka(czi1).x = Bajty_spr(pwps+6)*65536 + Bajty_spr(pwps+5)*256 + Bajty_spr(pwps+4)
		Wielkosc_obrazka(czi1).y = 1
		pwps+=16
	Next czi1
		
	Case Else	''przechodzimy do pobierania wielkosci obrazkow
	For czi1 = 1 To Ilosc_obrazkow
		Wielkosc_obrazka(czi1).x = Bajty_spr(pwps+1)*256 + Bajty_spr(pwps)
		Wielkosc_obrazka(czi1).y = Bajty_spr(pwps+3)*256 + Bajty_spr(pwps+2)
		If Centrowac_grafike = 1 Then
			Przes_obrazka(czi1).x = Bajty_spr(pwps+4)
			Przes_obrazka(czi1).y = Bajty_spr(pwps+6)
		EndIf
		If Wielkosc_obrazka(czi1).x > max_szer Then max_szer = Wielkosc_obrazka(czi1).x
		If Wielkosc_obrazka(czi1).y > max_wys Then max_wys = Wielkosc_obrazka(czi1).y
		''Print  "nr: " & czi1 & ", poz: " & pwps:Sleep

		''wymiary
		If czi1<20 Then
		Print "obrazek: " & czi1 & ": " & Wielkosc_obrazka(czi1).x & "x" & Wielkosc_obrazka(czi1).y & ", reszta: " & Bajty_spr(pwps+4) & "-" & Bajty_spr(pwps+5) & "-" & Bajty_spr(pwps+6) & "-" & Bajty_spr(pwps+7)
		EndIf

		pwps+=8
	Next czi1

End Select
pwps2=pwps

''Sleep 5000
last_buf_black = 128: last_buf_normal = 128: zawijac_czarne = 0

If Rodzaj_pliku = 11 Or Rodzaj_pliku = 12 Then	''archiwum trci trc/trw
	For czi1 = 1 To Ilosc_obrazkow
		Select Case LCase(Right(nazwa_pza(czi1), 4))
			Case ".scr", ".spr"
			''wczytaj palete .pal 768 bajtow
			Dim As UByte temp_pal_tric(767)	''rgb palette
			wp3 = FreeFile()
			Open Katalog_poczatek & Plik_obciety & "\" & Zwroc_plik(nazwa_pza(czi1)) & ".pal" For Binary As #wp3
			Get #wp3, , temp_pal_tric()
			Close #wp3
			pwps2=0
			For czi2 = 0 To 255
				Tab_palety(czi2) = RGB(temp_pal_tric(pwps2), temp_pal_tric(pwps2+1), temp_pal_tric(pwps2+2))
				pwps2 += 3
			Next czi2
			
			Dim As Any ptr Obrazek_teraz
			If LCase(Right(nazwa_pza(czi1), 4)) = ".spr" Then
				Wielkosc_obrazka(0).x = Bajty_spr(pwps+1)*256 + Bajty_spr(pwps)
				Wielkosc_obrazka(0).y = Bajty_spr(pwps+3)*256 + Bajty_spr(pwps+2)
				pwps+=12
			Else	''scr
				Wielkosc_obrazka(0).x = 640
				Wielkosc_obrazka(0).y = 480
			EndIf
			Obrazek_teraz = ImageCreate(Wielkosc_obrazka(0).x, Wielkosc_obrazka(0).y, 0, 32)
			For czi3 = 0 To Wielkosc_obrazka(0).y-1
				For czi2 = 0 To Wielkosc_obrazka(0).x-1
					PSet Obrazek_teraz, (czi2, czi3), Tab_palety(Bajty_spr(pwps))
					tab_pal_uzywana(Bajty_spr(pwps)) = 1
					pwps+=1
				Next czi2
			Next czi3
			If Png_czy_bmp = 0 Then
				png_save(Katalog_poczatek & Plik_obciety & "\" & nazwa_pza(czi1) & ".png", Obrazek_teraz)
			Else
				BSave(Katalog_poczatek & Plik_obciety & "\" & nazwa_pza(czi1) & ".bmp", Obrazek_teraz, 640 * 480 * 3)
			EndIf
			ImageDestroy(Obrazek_teraz)

			Case Else
			wp3 = FreeFile()
			Open Katalog_poczatek & Plik_obciety & "\" & nazwa_pza(czi1) For Binary As #wp3
			Put #wp3, , Bajty_spr(pwps), Wielkosc_obrazka(czi1).x
			Close #wp3
			pwps+=Wielkosc_obrazka(czi1).x
		End Select
	Next czi1
EndIf

''pobieranie danych obrazkow
For czi7 = 1 To 7
pwps=pwps2
czs2=czs1
/' usunac komentarz jezeli chcemy wyexportowane animacje wody
If Rodzaj_pliku=1 Then
	czs2 = czs1 & "\" & czi7
	If Not FileExists(czs2) Then MkDir czs2
EndIf
'/
If Rodzaj_pliku = 11 Or Rodzaj_pliku = 12 Then Exit For	''wyjdz z for gdy archiwum tric

For czi1 = 1 To Ilosc_obrazkow
last_buf_black = 128: last_buf_normal = 128
	
	Dim As Any ptr Obrazek_teraz
	If Centrowac_grafike = 0 Then
		Obrazek_teraz = ImageCreate(Wielkosc_obrazka(czi1).x, Wielkosc_obrazka(czi1).y, 0, 32)
	Else
		Obrazek_teraz = ImageCreate(Przes_obrazka(czi1).x + Wielkosc_obrazka(czi1).x, Przes_obrazka(czi1).y + Wielkosc_obrazka(czi1).y, 0, 32)
	EndIf
	Dim ret As Integer
	
	If Typ_pliku = 0 Then
		''bez kompresji
		If Rodzaj_pliku=1 And czi7=1 Then
			czi4 = Bajty_spr(pwps) + 256 * Bajty_spr(pwps+1)
			Print #wp2, Str(czi4) & " ; " & czi1
		EndIf

		If Rodzaj_pliku = 1 Then pwps+=4	''do mapy, id tile ma 4 bajty
		
		For czi3 = 0 To Wielkosc_obrazka(czi1).y - 1
			For czi2 = 0 To Wielkosc_obrazka(czi1).x - 1
				PSet Obrazek_teraz, (Przes_obrazka(czi1).x + czi2, Przes_obrazka(czi1).y + czi3), Tab_palety(Bajty_spr(pwps))
				tab_pal_uzywana(Bajty_spr(pwps)) = 1
				pwps+=1
			Next czi2
		Next czi3
	Else
		''skompresowany
		pwps+=4	''dodatkowe 4 bajty - nie wiem po co
		''Print "start: " & pwps
		''If czi1=3 Then Exit For
		czi2 = 0 ''ilosc skopmresowanych 00
		czi4 = 0: czi5 = 0	''czi4 - x, czi5 - y
		Do While czi5 < Wielkosc_obrazka(czi1).y And czi4 < Wielkosc_obrazka(czi1).x
		czi2 = 0: czi6 = 1
		''Print "poz: " & pwps & ", size: " & czi4 & "x" & czi5 & " na " & Wielkosc_obrazka(czi1).x & "x" & Wielkosc_obrazka(czi1).y & ", " & Bajty_spr(pwps) & "; " & czi6 
		Do While Bajty_spr(pwps) >= 128
			''Print "bajt: " & Bajty_spr(pwps) & ", pos: " & pwps
			czi2 = 256 - Bajty_spr(pwps)
			pwps+=1
			For czi3 = 1 To czi2	''wprowadzanie danej iloci 00
				PSet Obrazek_teraz, (Przes_obrazka(czi1).x + czi4, Przes_obrazka(czi1).y + czi5), 0
				tab_pal_uzywana(0) = 1
				czi4+=1
				If czi4 = Wielkosc_obrazka(czi1).x Then czi5+=1: czi4=0
			Next czi3
			If czi5 = Wielkosc_obrazka(czi1).y Then Exit Do: czi6 = 0
			If last_buf_black < 128 Then zawijac_czarne = 1
			last_buf_black = czi2
			last_buf_normal = 128
			''Print "zawijac: " & Str(zawijac_czarne) & ", pwps: " & Str(pwps)
		Loop
		If czi5 = Wielkosc_obrazka(czi1).y Then Exit Do: czi6 = 0
		''ilosc czystych bajtow
		''Print "poz: " & pwps & ", size: " & czi4 & "x" & czi5 & " na " & Wielkosc_obrazka(czi1).x & "x" & Wielkosc_obrazka(czi1).y & ", " & Bajty_spr(pwps) & "; " & czi6 
		If czi6 > 0 Then
		czi2 = Bajty_spr(pwps) + 1
		'Print czi1 & " - " & Bajty_spr(pwps) + 1
			If czi2 < 129 Then
			pwps+=1
			'Print czi1 & " - wchodze w czyste"
			For czi3 = 1 To czi2	''wprowadzanie danej iloci nieskompresowanych bajtow
				PSet Obrazek_teraz, (Przes_obrazka(czi1).x + czi4, Przes_obrazka(czi1).y + czi5), Tab_palety(Bajty_spr(pwps))
				tab_pal_uzywana(Bajty_spr(pwps)) = 1
				czi4+=1
				If czi4 = Wielkosc_obrazka(czi1).x Then czi5+=1: czi4=0
				pwps+=1
				'Print "skonczono nie skompresowane"
			Next czi3
			If last_buf_normal < 128 Then zawijac_czarne = 1
			last_buf_normal = czi2
			last_buf_black = 128
			''Print "zawijac: " & Str(zawijac_czarne) & ", pwps: " & Str(pwps)
	'Print "poz: " & pwps
			Else
				'Print "wieksze niz 128: " & czi2
	'Print "poz: " & pwps
			EndIf
		'Print "po ns, poz: " & pwps & ", size: " & czi4 & "x" & czi5 & " na " & Wielkosc_obrazka(czi1).x & "x" & Wielkosc_obrazka(czi1).y & ", " & Bajty_spr(pwps) 
		Else
			Print "koncowka tylko 00"
			''pwps+=4
		EndIf
		
		Loop	''koniec 
		
	EndIf

	''zapisz obrazek
	''BSave ExePath & "\" & czs2 & "\" & Str(czi1) & ".bmp", Obrazek_teraz, Wielkosc_obrazka(czi1).x * Wielkosc_obrazka(czi1).y * 3
	''nowe zapisywanie jako PNG
	czs1 = Str(czi1)
	Select Case As const Len(czs1)
		Case 1: czs1 = "000" & czs1
		Case 2: czs1 = "00" & czs1
		Case 3: czs1 = "0" & czs1
	End Select
	If Rodzaj_pliku=1 Then
		czs1 = Str(czi7) & "\" & czs1
	EndIf
	If Png_czy_bmp = 0 Then
		png_save(Katalog_poczatek & Plik_obciety & "\" & czs1 & ".png", Obrazek_teraz)
		Print Katalog_poczatek & Plik_obciety & "\" & czs1 & ".png, " & pwps
	Else
		BSave(Katalog_poczatek & Plik_obciety & "\" & czs1 & ".bmp", Obrazek_teraz, Wielkosc_obrazka(czi1).x * Wielkosc_obrazka(czi1).y * 3)
		Print Katalog_poczatek & Plik_obciety & "\" & czs1 & ".bmp, " & pwps
	EndIf
	
	ImageDestroy(Obrazek_teraz)
	
	
Next czi1
	''wyjdz jezeli nie plik z terenem
	If Rodzaj_pliku=1 Then
		Woda_anim_poz+=1
		If Woda_anim_poz > 6 Then Woda_anim_poz = 0
		For czi1 = 0 To 7
			czi2 = 201 + czi1 + Woda_anim_poz
			If czi2 > 207 Then czi2-=7
			tab_palety(czi2) = tab_palety_org(201+czi1)
			''Palette czi2, Paleta1(0, 201+czi1).r, Paleta1(0, 201+czi1).g, Paleta1(0, 201+czi1).b
		Next czi1
		''Exit For	''usunac komentarz dla wody
	Else
		Exit for
	EndIf
Next czi7

If Rodzaj_pliku=1 Then
	Close #wp2
EndIf


Print #wp1, zawijac_czarne
Close #wp1


''zapis naprawde uzywanej palety
Paletaimg = ImageCreate(256, 1, 0, 32)
Line Paletaimg, (0, 0) - (255, 0), Tab_palety(0)	''jednorodne tlo
For czi2 = 0 To 255
	If tab_pal_uzywana(czi2) = 1 Then PSet Paletaimg, (czi2, 0), Tab_palety(czi2)
Next czi2
BSave Katalog_poczatek & Plik_obciety & "\pal_used.bmp", Paletaimg, 768
ImageDestroy(Paletaimg)
''koniec



End Sub


Sub Map_view()
''podglad mapy
''grafika musi byc rozpoakowana do formatu bmp
''ReDim As Ubyte Bajty_spr()	''bajty z pliku .spr
Dim As LongInt Len_spr = 0	''dlugosc pliku .spr
Dim As LongInt Pwps = 0		''pozycja w pliku .spr

Dim As Integer czi1, czi2, czi3, czi4, czi5, czi6
Dim As UByte czub1, czub2, czub3, czub4
Dim As Integer Przes_x, Przes_y	''przesuniecie mapy x, y
Dim As Integer Wielkosc_x, Wielkosc_y	''wielkosc mapy
Dim As Integer wp1, wp2
Dim As String Czs1, Czs2, Czs3, Czs4
Dim As Integer Ilosc_bloczkow, Ilosc_obrazkow
Dim As UByte draw_line, draw_special
Dim As Integer Tab_palety(255)	''tablica z paleta colorow
Dim As typ_RGB Paleta1(2, 255)
''Const NULL As Any Ptr = 0


Input "Podaj nazwe jednostki: (drukowanymi literami np. TRSC) ", Czs4
If Czs4="" Then Czs4="REAP"


Dim Obrazki_jednostek(0) As Typ_obrazka_jednostki
''do animacji
Dim As Typ_opis_calej_animacji Animacja_jednostek(0)
''aktualnie tylko animacji reaper-a
Wczytaj_obrazki_animacji(Obrazki_jednostek(0), dc_path & "sprites\" & Czs4 & ".spr")
Wczytaj_animacje_jednostki(Animacja_jednostek(0), Obrazki_jednostek(0), Czs4, dc_path & "animate\")

/'
For czi1 = 0 To 100
	Print Animacja_jednostek(0).klatki_anim[czi1].id_obrazka
Next czi1
Print Animacja_jednostek(0).klatki_anim[39].id_obrazka
'/

Input "choose type of tile-set: (desert, jungle...) ", czs3
'katalogi / pliki
czs1 = Left(Plik_obrabiany, Len(Plik_obrabiany)-4)


If Not FileExists(dc_path &  "scenario\" & czs3 & ".bts") Then Print "Error: no file with tiles | brak pliku .bts"
''plik z id bloczkow mapy
Len_spr = FileLen(dc_path &  "scenario\" & czs3 & ".bts")
ReDim Bajty_spr(Len_spr-1)

wp1 = FreeFile
Open dc_path &  "scenario\" & czs3 & ".bts" For Binary As wp1
Get #wp1, , Bajty_spr()
Close #wp1

pwps = 8
For czi1 = 0 To 255
	czub1 = 4*Bajty_spr(pwps): If Not czub1=0 Then czub1+=3
	czub2 = 4*Bajty_spr(pwps+1): If Not czub2=0 Then czub2+=3
	czub3 = 4*Bajty_spr(pwps+2): If Not czub3=0 Then czub3+=3
	Tab_palety(czi1) = RGB(czub1, czub2, czub3)
	Paleta1(0, czi1).r = czub1
	Paleta1(0, czi1).g = czub2
	Paleta1(0, czi1).b = czub3
	pwps+=3
	'pset Paletaimg2, (czi1, 0), RGB(czub1, czub2, czub3)
Next czi1
Ilosc_obrazkow = Bajty_spr(5) * 256 + Bajty_spr(4)
pwps = 776


Dim As Integer Id_bloczkow(Ilosc_obrazkow*2)
Ilosc_bloczkow = Ilosc_obrazkow*2-1
For czi1 = 0 To Ilosc_bloczkow-1 Step 2
	czi3=(czi1-1)*2
	czi2 = Bajty_spr(pwps) + 256 * Bajty_spr(pwps+1)
	Id_bloczkow(czi1) = czi2
	Id_bloczkow(czi1+1) = czi2
	'Print czi1 & " : " & czi2
	pwps+=1028
Next czi1
pwps = 780
'Sleep 5000
	
	''zwiekszane o 2 poniewaz wbudowana w FB biblioteka do grafiki nie ma mozliwosci obracania obrazkow
	''dlatego drugi obrazek bedzie lustrzana kopia pierwszego - to samo id, jednak odwrocony
	''wymaga to 2x wiekszej pamieci jednak obecnie dla testow to nie przeszkadza
	''w razie uzywania np. DX mozna korzystac ze sprzetowego efektu mirror dla grafiki 2d

Dim As Any ptr Obraz_bmp(Ilosc_bloczkow)
For czi1 = 0 To Ilosc_bloczkow-1 Step 2
	czi2 = czi1\2
	Obraz_bmp(czi1) = ImageCreate(32, 32, 0, 8)
	Obraz_bmp(czi1+1) = ImageCreate(32, 32, 0, 8)
	'BLoad ExePath & "\" & czs3 & "\" & Str(czi2+1) & ".bmp", Obraz_bmp(czi1)
	
	For czi3 = 0 To 31
		For czi2 = 0 To 31
			czub1 = Bajty_spr(pwps)
			'PSet Obrazek_teraz, (czi2, czi3), Tab_palety(Bajty_spr(pwps))
			PSet Obraz_bmp(czi1), (czi2, czi3), czub1
			PSet Obraz_bmp(czi1+1), (31-czi2, czi3), czub1
			''PSet (czi2, czi3+czi1*32), czub1
			pwps+=1
		Next czi2
	Next czi3
	pwps+=4
Next czi1

	'Paletaimg = ImageCreate(16, 16, 0, 32)
	'Dim ret As Integer
	'ret = BLoad(ExePath & "\" & Plik_palety, Paletaimg)
Print "wczytano obrazki: " & Ilosc_obrazkow


Len_spr = FileLen(Plik_obrabiany)
ReDim Bajty_spr(Len_spr-1)

wp1 = FreeFile
Open Plik_obrabiany For Binary As #wp1
	Get #wp1, ,Bajty_spr()
Close #wp1

Wielkosc_x = Bajty_spr(0) + Bajty_spr(1)*256
Wielkosc_y = Bajty_spr(4) + Bajty_spr(5)*256
Print "x: " & wielkosc_x & ", y: " & wielkosc_y
Dim As tab_id Tab_mapy(Wielkosc_x, Wielkosc_y)
Dim As UByte tab_ub(3, wielkosc_x, wielkosc_y)
Print "mapa: " & wielkosc_x & "x" & wielkosc_y

''wczytywanie danych mapy
pwps = 8
czi5 = 0
czi6 = wielkosc_x*wielkosc_y*4+8
For czi2 = 1 To Wielkosc_y
	For czi1 = 1 To Wielkosc_x
		czi3 = Bajty_spr(pwps) + 256 * Bajty_spr(pwps+1)	''id bloczka tylniej warstwy
		tab_ub(0, czi1, czi2) = Bajty_spr(czi6+czi5*2)
		tab_ub(1, czi1, czi2) = Bajty_spr(czi6+czi5*2+1)
		tab_ub(2, czi1, czi2) = 0
		For czi4 = 0 To Ilosc_bloczkow - 1
			If Id_bloczkow(czi4) = czi3 Then Tab_mapy(czi1, czi2).id1 = czi4: Exit For
		Next
		czi3 = Bajty_spr(pwps+2) + 256 * Bajty_spr(pwps+3)	''id bloczka wierzchniej warstwy
		If czi3 > 0 Then
			Tab_mapy(czi1, czi2).is_id2 = 1
			For czi4 = 0 To Ilosc_bloczkow - 1
				If Id_bloczkow(czi4) = czi3 Then Tab_mapy(czi1, czi2).id2 = czi4: Exit For
			Next
			''poprawki na obrot dla wierzchniej warstwy
			If (tab_ub(0, czi1, czi2) > 96 And tab_ub(0, czi1, czi2) < 100) Or (tab_ub(0, czi1, czi2) > 223 And tab_ub(0, czi1, czi2) < 228) Or (tab_ub(0, czi1, czi2) > 63 And tab_ub(0, czi1, czi2) < 68) Or tab_ub(0, czi1, czi2)=193 Then Tab_mapy(czi1, czi2).id2+=1: Tab_mapy(czi1, czi2).id1+=1
			If tab_ub(0, czi1, czi2) = 161 Then Tab_mapy(czi1, czi2).id1+=1
		Else
			''poprawki na obrot dla tylkniej warstwy
			If (tab_ub(0, czi1, czi2) > 159 And tab_ub(0, czi1, czi2) < 163) Or (tab_ub(0, czi1, czi2) > 223 And tab_ub(0, czi1, czi2) < 228) Or (tab_ub(0, czi1, czi2) > 95 And tab_ub(0, czi1, czi2) < 100) Or (tab_ub(0, czi1, czi2) = 32 Or tab_ub(0, czi1, czi2)=193) Then Tab_mapy(czi1, czi2).id1+=1
		EndIf
		''typ blokowania
		If (tab_ub(1, czi1, czi2) = 2 Or tab_ub(1, czi1, czi2) = 14 Or tab_ub(1, czi1, czi2) = 18 Or tab_ub(1, czi1, czi2) = 30 Or tab_ub(1, czi1, czi2) = 6 Or tab_ub(1, czi1, czi2) = 54 Or tab_ub(1, czi1, czi2) = 42 Or tab_ub(1, czi1, czi2) = 50 Or tab_ub(1, czi1, czi2) = 90 Or tab_ub(1, czi1, czi2) = 58 Or tab_ub(1, czi1, czi2) = 78 Or tab_ub(1, czi1, czi2) = 82 Or tab_ub(1, czi1, czi2) = 46 Or tab_ub(1, czi1, czi2) = 66 Or tab_ub(1, czi1, czi2) = 62 Or tab_ub(1, czi1, czi2) = 70) Then tab_ub(2, czi1, czi2) = 103	''niebieskie
		If (tab_ub(0, czi1, czi2) < 128) Then
			If (tab_ub(2, czi1, czi2) = 103) Then
				tab_ub(2, czi1, czi2) = 72	''zolte
			Else
				tab_ub(2, czi1, czi2) = 121	''zielone
			EndIf
		EndIf
		If (tab_ub(1, czi1, czi2) = 49 Or tab_ub(1, czi1, czi2) = 77 Or tab_ub(1, czi1, czi2) = 89) Then tab_ub(2, czi1, czi2) = 200	''rozowe
		
		pwps+=4
		czi5+=1
	Next czi1
Next czi2
Print "wczytano mape - wcisnij dowolny klawisz"
''mapa wczytana z przekonwertowaniem
''wczytywanie obrazkow
Dim As Double Woda_anim1, Woda_anim2, Czas_aktualny
Dim As Integer Woda_anim_poz = 0
Woda_anim1 = Timer()

Do While InKey$="":Sleep 10: Loop

For czi1=0 To 255
	Palette czi1, Paleta1(0, czi1).r, Paleta1(0, czi1).g, Paleta1(0, czi1).b
Next czi1
Cls
czs1 = Animacja_jednostek(0).id_nazwa: czs2 = "MOVE": czs3 = "12"


''petla wyswietlajaca
Dim As UByte robic = 1
Do While robic = 1
	
	Czas_aktualny = Timer()
	''anim wody
	If czas_aktualny-woda_anim1>=0.1 Then
		woda_anim1 = czas_aktualny
		Woda_anim_poz+=1
		If Woda_anim_poz > 6 Then Woda_anim_poz = 0
		For czi1 = 0 To 7
			czi2 = 201 + czi1 + Woda_anim_poz
			If czi2 > 207 Then czi2-=7
			Palette czi2, Paleta1(0, 201+czi1).r, Paleta1(0, 201+czi1).g, Paleta1(0, 201+czi1).b
		Next czi1
		
		''animacja jednostki
		Animacja_jednostek(0).nr_klatki+=1
		If Animacja_jednostek(0).nr_klatki > Animacja_jednostek(0).panimacja(Animacja_jednostek(0).id_animacji).nr2 Then Animacja_jednostek(0).nr_klatki = Animacja_jednostek(0).panimacja(Animacja_jednostek(0).id_animacji).nr1
	EndIf
	

	If MultiKey(FB.SC_ESCAPE) Then Robic = 0
	If MultiKey(FB.SC_LEFT) And Przes_x > 0 Then Przes_x-=1
	If MultiKey(FB.SC_RIGHT) And Przes_x < Wielkosc_x - 20 Then Przes_x+=1
	If MultiKey(FB.SC_UP) And Przes_y > 0 Then Przes_y-=1
	If MultiKey(FB.SC_DOWN) And Przes_y < Wielkosc_y - 15 Then Przes_y+=1
	If MultiKey(FB.SC_Q) Then draw_line=(draw_line+1) Mod 2
	If MultiKey(FB.SC_W) Then draw_special=(draw_special+1) Mod 3
	
	If MultiKey(FB.SC_1) Then czs3 = "2"
	If MultiKey(FB.SC_2) Then czs3 = "0"
	If MultiKey(FB.SC_3) Then czs3 = "14"
	If MultiKey(FB.SC_4) Then czs3 = "4"
	If MultiKey(FB.SC_6) Then czs3 = "12"
	If MultiKey(FB.SC_7) Then czs3 = "6"
	If MultiKey(FB.SC_8) Then czs3 = "8"
	If MultiKey(FB.SC_9) Then czs3 = "10"
	If MultiKey(FB.SC_M) Then czs2 = "MOVE"
	If MultiKey(FB.SC_D) Then czs2 = "DIEB"
	If MultiKey(FB.SC_F) Then czs2 = "FIRE"
	''ustalanie animacji
	For czi1 = 0 To Animacja_jednostek(0).il_panimacji-1
		If Animacja_jednostek(0).panimacja(czi1).nazwa = Str(czs1 & czs2 & czs3) Then
			If Animacja_jednostek(0).id_animacji <> czi1 Then Animacja_jednostek(0).nr_klatki = Animacja_jednostek(0).panimacja(czi1).nr1
			Animacja_jednostek(0).id_animacji = czi1
			Exit For
		EndIf
	Next czi1
''WindowTitle "'" & Str(czs1 & czs2 & czs3) & "'"

	For czi2 = 1 To 15
		czi4 = Przes_y + czi2
		For czi1 = 1 To 20
			czi3 = Przes_x + czi1
			Put ((czi1-1)*32, (czi2-1)*32), Obraz_bmp(Tab_mapy(czi3, czi4).id1), PSet
			If Tab_mapy(czi3, czi4).is_id2 Then Put ((czi1-1)*32, (czi2-1)*32), Obraz_bmp(Tab_mapy(czi3, czi4).id2), Trans
		Next czi1
	Next czi2
If draw_special > 0 Then	
	For czi2 = 1 To 15
		czi4 = Przes_y + czi2
		For czi1 = 1 To 20
			czi3 = Przes_x + czi1
			If tab_ub(draw_special, czi3, czi4)>0 Then Line ((czi1-1)*32, (czi2-1)*32)-(czi1*32, czi2*32), tab_ub(draw_special, czi3, czi4), bf
		Next czi1
	Next czi2
EndIf


''jednostka
''Put (200 - Animacja_jednostek(0).klatki_anim[Animacja_jednostek(0).nr_klatki].przes_x, 200 - Animacja_jednostek(0).klatki_anim[Animacja_jednostek(0).nr_klatki].przes_y), Obrazki_jednostek(0).obrazek(Animacja_jednostek(0).nr_klatki), Pset 
Put (160 - Animacja_jednostek(0).klatki_anim(Animacja_jednostek(0).nr_klatki).przes_x, 160 - Animacja_jednostek(0).klatki_anim(Animacja_jednostek(0).nr_klatki).przes_y), Obrazki_jednostek(0).obrazek(Animacja_jednostek(0).klatki_anim(Animacja_jednostek(0).nr_klatki).id_obrazka), trans 
''WindowTitle Animacja_jednostek(0).nr_klatki & " : " & Str(Animacja_jednostek(0).klatki_anim[Animacja_jednostek(0).nr_klatki].id_obrazka)

If draw_line = 1 Then
	For czi1 = 1 To 15
		Line (czi1*32-1, 0)-(czi1*32-1, 400), 255
		Line (0, czi1*32-1)-(400, czi1*32-1), 255
	Next
EndIf

'For czi1 = 0 To 255
'Line (czi1+1, 0)-(czi1+1, 400), czi1
'Next


GetMouse czi1, czi2
czi1=czi1\32+1+przes_x
czi2=czi2\32+1+przes_y
WindowTitle czi1 & "x" & czi2 & ", val: " & tab_ub(0, czi1, czi2) & "-" & tab_ub(1, czi1, czi2) & ", podklad: " & Tab_mapy(czi1, czi2).id1 & "-" & Tab_mapy(czi1, czi2).id2
	
Sleep 50
Loop


For czi1 = 0 To Ilosc_bloczkow-1
	ImageDestroy(Obraz_bmp(czi1))
Next

For czi1 = 0 To 0
	'DeAllocate(Animacja_jednostek(czi1).panimacja)
	'DeAllocate(Animacja_jednostek(czi1).klatki_anim)
	For czi2 = 0 To Obrazki_jednostek(czi1).liczba_obrazkow - 1
		ImageDestroy(Obrazki_jednostek(czi1).obrazek(czi2))
	Next czi2
Next czi1

	
End Sub


Sub Tworz_spr()
''procedura zamieniajaca bmp w spr

''ReDim As Ubyte Bajty_spr()	''bajty z pliku .spr
Dim As LongInt Len_spr = 0	''dlugosc pliku .spr
Dim As LongInt Pwps, pwps2		''pozycja w pliku .spr
Dim As Integer Czi1, Czi2, Czi3, Czi4, Czi5, Czi6, Czi7, Czi8, Czi9	''z dedykacja dla Maranty :D
Dim As UByte Czub1, Czub2, Czub3
Dim As UInteger Tab_palety(255)	''tablica z paleta colorow
Dim As UInteger Tab_palety_org(255)	''oryginalna tablica z paleta
Dim As String czs1, czs2, czs3
Dim As UByte Typ_pliku = 0	''zwykly, skompresowany...
Dim As Integer Woda_anim_poz = 0	''do animacji wody ;]
Dim As UByte Centrowac_grafike = 0	''czy doklejac brakujace el tla - centrowanie grafiki
Dim As Integer Ilosc_obrazkow = 0
Dim As Integer max_szer, max_wys
Dim As UByte Spr_czy_bts = 0	''0 - spr, 1 - bts
Dim As UByte Zawijac_czarne = 0	''zawijanie czarnych linii pzy dojsciu do konca wiersza
Dim As Integer wp1, wp2, wp3

ReDim As UByte Bajty_spr2()
Dim As LongInt Len_spr2 = 0	''dlugosc pliku .spr
ReDim As String Nazwa_pliku()


''najpierw trzeba ustalic poprawny katalog z, ktorego sa pobierane pliki bmp
czs1 = ExePath & "\" & Plik_obrabiany
czi2 = 1: czi3 = 1
czi1 = InStr(czi2, czs1, "\")
Do While (czi1 > 0)
	czi4 = czi3
	czi3 = czi1
	czi2 = czi1 + 1
	czi1 = InStr(czi2, czs1, "\")
	''Print czi4 & " : " & czi3 & " : " & czi1
Loop
czs2 = Mid(czs1, czi4 + 1, czi3 - czi4 - 1)
czs1 = Left(czs1, czi2 - 1)
Print "katalog: '" & czs1 & "'"
Print "koncowka: '" & czs2 & "'"
czs3 = czs2: czs2 = ""
''katalog ustalony
czs1 = Katalog_poczatek
czs2 = ""
czs3 = Katalog_koncowka

''plik ustawien tworzenia spr
wp1 = FreeFile
Open Katalog_poczatek & "build.txt" For Input As #wp1
Input #wp1, czs2	''pierwsza linijka to komentarz
Input #wp1, czs2
Spr_czy_bts = CUByte(Val(czs2))
Input #wp1, czs2
Typ_pliku = CUByte(val(czs2))
Input #wp1, czs2
Zawijac_czarne = CUByte(val(czs2))
Close #wp1
czs2 = ""
''koniec

''zawijac
''Input "Zawijac przy koncu wiersza"; czs2
''If InStr(czs2, "t") > 0 Or Val(czs2) = 1 Then Zawijac_czarne = 1
czs2 = ""
''koniec zawijania

''zliczanie ilosci plikow bmp
czi1 = 0
czs2 = Dir(czs1 & "*.png", &h21)
Do While Len(czs2) > 0
	czi1+=1
	czs2 = Dir()
Loop
ReDim Nazwa_pliku(czi1)
czi1 = 0
czs2 = Dir(czs1 & "*.png", &h21)
Do While Len(czs2) > 0
	czi1+=1
	Nazwa_pliku(czi1) = czs1 & czs2
	czs2 = Dir()
Loop
Print "Znalezono plikow png: " & czi1
If czi1 = 0 Then Print "Brak plikow!": Exit Sub
''zliczono pliki
Dim As UInteger tab_id_bts(czi1)



''paleta
Dim As Any ptr Paletaimg
Paletaimg = ImageCreate(256, 1, 0, 32)
BLoad(czs1 & "palette.bmp", Paletaimg)
For czi2 = 0 To 255
	Tab_palety(czi2) = Point(czi2, 0, Paletaimg)
Next czi2
ImageDestroy(Paletaimg)
''koniec ustalania palety


''wpisywanie naglowka SPR
ReDim Bajty_spr(0)
If Spr_czy_bts = 0 Then
	Len_spr = 776 + 8 * czi1
	ReDim Bajty_spr(Len_spr)
	Bajty_spr(0) = 129
	Bajty_spr(1) = 0
	Bajty_spr(2) = czi1 Mod 256
	Bajty_spr(3) = czi1 \ 256
Else
	Len_spr = 776	''dane zaczynaja sie odrazu
	ReDim Bajty_spr(Len_spr)
	Select Case Katalog_koncowka
		Case "desert"
			Bajty_spr(0) = 236: Bajty_spr(1) = 19
		Case "jungle", "htrain", "special2", "trainh"
			Bajty_spr(0) = 68: Bajty_spr(1) = 22
		Case "atlantis", "special"
			Bajty_spr(0) = 112: Bajty_spr(1) = 23
		Case Else
			Bajty_spr(0) = 112: Bajty_spr(1) = 23
	End Select

	czi3 = czi1 \ 16777216
	czi4 = (czi1 - czi3) \ 65536
	czi5 = (czi1 - czi4*65536 - czi3*16777216) \ 256
	czi6 = (czi1 - czi4*65536 - czi3*16777216 - czi5*256)
	'Bajty_spr(4) = czi6
	'Bajty_spr(5) = czi5
	'Bajty_spr(6) = czi4
	'Bajty_spr(7) = czi3
	Bajty_spr(4) = CUByte(czi1 Mod 256)
	Bajty_spr(5) = CUByte(czi1 \ 256)
	''wczytanie id bloczkow terenu
	wp1 = FreeFile
	Open Katalog_poczatek & Katalog_koncowka & ".txt" For Input As #wp1
	For czi2 = 1 To czi1
		Input #wp1, czs2
		tab_id_bts(czi2) = Val(czs2)
	Next czi2
	Close #wp1
	czs2 = ""
EndIf

''dopisywanie palety to tworzonego pliku
For czi2 = 0 To 255
	czi3 = Tab_palety(czi2) Mod 16777216
	czi4 = czi3 \ 65536
	czi5 = (czi3 - czi4*65536) \ 256
	czi6 = (czi3 - czi4*65536 - czi5*256)
	If czi4>3 Then czi4-=3
	If czi5>3 Then czi5-=3
	If czi6>3 Then czi6-=3
	czi4 = czi4 / 4
	czi5 = czi5 / 4
	czi6 = czi6 / 4
	Bajty_spr(8 + czi2*3 + 0) = CUByte(czi4)
	Bajty_spr(8 + czi2*3 + 1) = CUByte(czi5)
	Bajty_spr(8 + czi2*3 + 2) = CUByte(czi6)
Next

''paleta ujednolicona - jezeli istnieje
/'If FileExists(ExePath & "\palette.bmp") Then
	Paletaimg = ImageCreate(256, 1, 0, 32)
	BLoad(ExePath & "\palette.bmp", Paletaimg)
	For czi2 = 0 To 255
		Tab_palety(czi2) = Point(czi2, 0, Paletaimg)
	Next czi2
	ImageDestroy(Paletaimg)
EndIf'/
''koniec ustalania palety

''koniec naglowka
Dim As Any Ptr Obraz_img
''petla glowna
For czi2 = 1 To czi1
	''petla glowna - poszczegolne pliki obrabiane
''	Obraz_img = ImageCreate()
	''If Obraz_img = NULL Then Print "dupczak!"
	''Dim As Any Ptr Obraz_img = png_load(Nazwa_pliku(czi2))
	Obraz_img = png_load(Nazwa_pliku(czi2))
	If (Not FileExists(Nazwa_pliku(czi2)) Or Obraz_img = Null) Then Print "zle: " & czi2 & " - " & Nazwa_pliku(czi2): Sleep 1000
	''If Not FileExists("D:\ben\testy programw\spr2bmp\gdb.exe") Then Print "zle: " & czi2 & " - D:\ben\testy programw\spr2bmp\gdb.exe": Sleep 2000
	Dim As UInteger czui1, czui2, czui3
	''png_dimensions(Nazwa_pliku(czi2), czui1, czui2)	''error
	Pobierz_wymiar(Nazwa_pliku(czi2), czui1, czui2)
	ReDim Bajty_spr2(czui1 * czui2 * 1.128)
	Len_spr2 = 0
	''If czi2 >500 Then Print "size: " & czui1 & "x" & czui2: Sleep 1000
	
	''Print nazwa_pliku(czi2)
	''Print "wielkosc pliku: " & czui1 & " : " & czui2
	
	''wyznaczanie gdzie zaczyna sie wlasciwy obrazek
	czi5 = czui1
	czi6 = czui2
	For czi4 = 0 To czui2-1	''y
		For czi3 = 0 To czui1-1	''x
			If Not Point(czi3, czi4, Obraz_img) = 0 Then
				If czi3 < czi5 Then czi5 = czi3	''x pierwszy pixel od lewej
				If czi4 < czi6 Then czi6 = czi4	''y pierwszy pixel od gory
			EndIf
		Next czi3
	Next czi4
	''wyznaczono

	
	''przygotowywanie obrazka w formacie spr
	czi7 = 0	''dlugosc buf z kolorem przezroczystym
	czi8 = 0	''typ bufora, 0 - przezroczyste, 1 - normalny kolor
	Dim As UByte buf_spr(128)


''sprawdzone, nie to
	If Typ_pliku = 0 Then
		''nie skompresowany
	For czi4 = czi6 To czui2-1
		For czi3 = czi5 To czui1-1
			''Print "robitka"
			czub1 = 0
			''znalezienie odpowiedniego koloru w palecie
			czui3 = Point(czi3, czi4, Obraz_img)
			For czi9 = 0 To 255
				If czui3 = Tab_palety(czi9) Then czub1 = CUByte(czi9): Exit For
			Next
			''koniec
			
			''wpisanie koloru
			Bajty_spr2(Len_spr2 + 1) = czub1
			Len_spr2 += 1
		Next
	Next

	ElseIf Typ_pliku = 1 Then
		''skompresowany
	For czi4 = czi6 To czui2-1
		For czi3 = czi5 To czui1-1
			''Print "robitka"
			czub1 = 0
			''znalezienie odpowiedniego koloru w palecie
			czui3 = Point(czi3, czi4, Obraz_img)
			For czi9 = 0 To 255
				If czui3 = Tab_palety(czi9) Then czub1 = CUByte(czi9)
				''mozna dodac optymalizacje z Exit For
				''jednak wtedy nie ma 100% kompatybilnosci z plikami z DC
			Next
			''koniec
				
			If czub1 = 0 Then	''czy kolor przezroczysty
				If czi8 = 1 Then	''zapisz normalne kolory
					''Print "dziwne"
					If czi7 > 0 Then
						Bajty_spr2(Len_spr2 + 1) = CUByte(czi7) - 1
						For czi9 = 1 To czi7
							Bajty_spr2(Len_spr2 + 1 + czi9) = buf_spr(czi9)
						Next
						Len_spr2 += czi7 + 1
					EndIf
					czi8 = 0
					czi7 = 1
					If Zawijac_czarne = 1 Then
						If (czi3 = czui1-1) Then	''poprawka na koniec obrazka w poziomie
							Bajty_spr2(Len_spr2 + 1) = 255
							Len_spr2+=1
							czi7 = 0
						EndIf
					EndIf
				Else
					''Print "koko" & czi7
					czi7+=1
					If Zawijac_czarne = 1 Then
						If (czi7=128) Or (czi3 = czui1-1) Then	''bufor osiagnal max dlugosc, trzeba zapisac
							''Print "ta"
							Bajty_spr2(Len_spr2 + 1) = 256 - CUByte(czi7)
							Len_spr2+=1
							czi7 = 0
						EndIf
					Else
						If (czi7=128) Or ((czi3 = czui1-1) And (czi4 = czui2-1)) Then	''bufor osiagnal max dlugosc, trzeba zapisac
							''Print "ta"
							Bajty_spr2(Len_spr2 + 1) = 256 - CUByte(czi7)
							Len_spr2+=1
							czi7 = 0
						EndIf
					EndIf
				EndIf
			Else ''normalny kolor
				If czi8 = 1 Then	''dodac kolor do bufora
					czi7+=1
					buf_spr(czi7) = czub1
					If Zawijac_czarne = 1 Then
						If (czi7=128) Or (czi3 = czui1-1) Then
							Bajty_spr2(Len_spr2 + 1) = CUByte(czi7) - 1
							For czi9 = 1 To czi7
								Bajty_spr2(Len_spr2 + 1 + czi9) = buf_spr(czi9)
							Next
							Len_spr2 += czi7 + 1
							czi7 = 0
						EndIf
					Else
						If (czi7=128) Or ((czi3 = czui1-1) And (czi4 = czui2-1)) Then
							Bajty_spr2(Len_spr2 + 1) = CUByte(czi7) - 1
							For czi9 = 1 To czi7
								Bajty_spr2(Len_spr2 + 1 + czi9) = buf_spr(czi9)
							Next
							Len_spr2 += czi7 + 1
							czi7 = 0
						EndIf
					EndIf
				Else	''zapisac przezroczyste pixele
					If czi7 > 0 Then
						Bajty_spr2(Len_spr2 + 1) = 256 - CUByte(czi7)
						Len_spr2+=1
					EndIf
					czi7 = 1
					czi8 = 1
					buf_spr(1) = czub1
					
					If Zawijac_czarne = 1 Then
						If (czi3 = czui1-1) Then	''poprawka na koniec obrazka w poziomie
							Bajty_spr2(Len_spr2 + 1) = 0
							Bajty_spr2(Len_spr2 + 2) = czub1
							Len_spr2+=2
							czi7 = 0
						EndIf
					EndIf
				EndIf
			EndIf
		Next
	Next
	''koniec
	
	EndIf

	
	''Print "koniec na: " & czi3 & " : " & czi4
	Print "plik: " & nazwa_pliku(czi2) & ", bufor spr2: " & len_spr2

	''DeAllocate(Obraz_img)
	''Png_destroy(Obraz_img)
	''DeAllocate(Obraz_img)
	ImageDestroy(Obraz_img)
	''Obraz_img = NULL
	''dopisanie info o obrazku
	If Spr_czy_bts = 0 Then	''for spr
		''wielkosc
		czi3 = (czi2-1)*8
		Bajty_spr(776 + czi3 + 0) = (czui1 - czi5) Mod 256
		Bajty_spr(776 + czi3 + 1) = (czui1 - czi5) \ 256
		Bajty_spr(776 + czi3 + 2) = (czui2 - czi6) Mod 256
		Bajty_spr(776 + czi3 + 3) = (czui2 - czi6) \ 256
		''przesuniecie
		Bajty_spr(776 + czi3 + 4) = czi5 Mod 256
		Bajty_spr(776 + czi3 + 5) = czi5 \ 256
		Bajty_spr(776 + czi3 + 6) = czi6 Mod 256
		Bajty_spr(776 + czi3 + 7) = czi6 \ 256
	EndIf
	
	''reszta
	czi3 = Len_spr2 \ 16777216
	czi4 = (Len_spr2 - czi3) \ 65536
	czi5 = (Len_spr2 - czi4*65536 - czi3*16777216) \ 256
	czi6 = (Len_spr2 - czi4*65536 - czi3*16777216 - czi5*256)
	
	If Spr_czy_bts = 0 Then
		ReDim Preserve Bajty_spr(Len_spr + Len_spr2 + (4*Typ_pliku))
		If Typ_pliku = 0 Then
			Bajty_spr(0) = 1
			For czi3 = 1 To Len_spr2
				Bajty_spr(Len_spr + czi3 - 1) = Bajty_spr2(czi3)
			Next
			''problem z zakodowana dlugoscia nieskompresowanych obrazkow - jedyna niezgodnosc z oryginalnymi .spr
		ElseIf Typ_pliku = 1 Then
			Bajty_spr(0) = 129
			Bajty_spr(Len_spr + 0) = CUByte(czi6)
			Bajty_spr(Len_spr + 1) = CUByte(czi5)
			Bajty_spr(Len_spr + 2) = CUByte(czi4)
			Bajty_spr(Len_spr + 3) = CUByte(czi3)
			For czi3 = 1 To Len_spr2
				Bajty_spr(Len_spr + 3 + czi3) = Bajty_spr2(czi3)
			Next
		EndIf
		Len_spr = Len_spr + Len_spr2 + (4*Typ_pliku)
	Else
		ReDim Preserve Bajty_spr(Len_spr + Len_spr2 + 4)
		czi3 = tab_id_bts(czi2) \ 16777216
		czi4 = (tab_id_bts(czi2) - czi3) \ 65536
		czi5 = (tab_id_bts(czi2) - czi4*65536 - czi3*16777216) \ 256
		czi6 = (tab_id_bts(czi2) - czi4*65536 - czi3*16777216 - czi5*256)
		Bajty_spr(Len_spr + 0) = czi6
		Bajty_spr(Len_spr + 1) = czi5
		Bajty_spr(Len_spr + 2) = czi4
		Bajty_spr(Len_spr + 3) = czi3
		For czi3 = 1 To Len_spr2
			Bajty_spr(Len_spr + 3 + czi3) = Bajty_spr2(czi3)
		Next
		Len_spr = Len_spr + Len_spr2 + 4
	EndIf

	
Next czi2


''Len_spr
ReDim Preserve Bajty_spr(Len_spr - 1)
czi7 = Len_spr - 776 - czi1 * (8 + 4*Typ_pliku)
If Spr_czy_bts = 0 And Typ_pliku = 0 Then
	czi7 = Len_spr - 776 + 4 * czi1	
EndIf
czi3 = czi7 \ 16777216
czi4 = (czi7 - czi3) \ 65536
czi5 = (czi7 - czi4*65536 - czi3*16777216) \ 256
czi6 = (czi7 - czi4*65536 - czi3*16777216 - czi5*256)
If Spr_czy_bts = 0 Then
	Bajty_spr(4) = CUByte(czi6)
	Bajty_spr(5) = CUByte(czi5)
	Bajty_spr(6) = CUByte(czi4)
	Bajty_spr(7) = CUByte(czi3)
EndIf
''Bajty_spr()


''zapisanie bufora do pliku
If Spr_czy_bts = 0 Then
	czs3 = czs1 & czs3 & "_new.spr"
Else
	czs3 = czs1 & czs3 & "_new.bts"
EndIf
If FileExists(czs3) Then Kill(czs3)
Print "Plik wynikowy: " & czs3

wp1 = FreeFile
Open czs3 For Binary As #wp1
Put #wp1, , Bajty_spr()
Close #wp1



	
End Sub


Sub Wczytaj_ustawienia()
Dim As Integer wp1, czi1, czi2, czi3
Dim As String czs1, czs2, czs3

If Not FileExists(ExePath & "\setup.txt") Then Print "No setup file!": Exit sub

wp1=FreeFile
Open ExePath & "\setup.txt" For Input As #wp1
Do While Not Eof(wp1)
	Input #wp1, czs1
	czi1 = InStr(czs1, "=")
	If czi1>0 And Left(czs1, 1)<>"'" Then
		czs2 = left(czs1, czi1-1)
		czs3 = Mid(czs1, czi1+1)
		Select Case czs2
			Case "DCpath"
				DC_path = czs3
				If Right(DC_Path, 1) <> "\" Then DC_path = DC_path & "\"
		End Select
	EndIf
Loop
Close #wp1

	'' :-)
End Sub


Sub Rozpisz_animacje()
''ReDim As Ubyte Bajty_spr()	''bajty z pliku .spr
Dim As LongInt Len_spr = 0	''dlugosc pliku .spr
Dim As LongInt Pwps, pwps2		''pozycja w pliku .spr

Dim As Integer czi1, czi2, czi3, czi4, czi5, czi6, czi7
Dim As UByte czub1, czub2, czub3, czub4
Dim As Integer Przes_x, Przes_y	''przesuniecie mapy x, y
Dim As Integer Wielkosc_x, Wielkosc_y	''wielkosc mapy
Dim As Integer wp1, wp2
Dim As String Czs1, Czs2, Czs3, Czs4
Dim As Integer Ilosc_bloczkow, Ilosc_obrazkow
Dim As UByte draw_line, draw_special
Dim As Integer Tab_palety(255)	''tablica z paleta colorow
Dim As typ_RGB Paleta1(2, 255)
''Const NULL As Any Ptr = 0


Input "pomijana animacja: (BLOOD, SMOKEY ...) ", czs4


Len_spr = FileLen(Plik_obrabiany)
ReDim Bajty_spr(Len_spr-1)


wp1=FreeFile
Open Plik_obrabiany For Binary As wp1
Get #wp1, , Bajty_spr()
Close #wp1


''katalogi / pliki
/'
czs1 = Katalog_poczatek & Plik_obciety & "\"
If Len(czs1) > 20 Then czs1 = "output"
If Not FileExists(ExePath & "\" & czs1) Then MkDir ExePath & "\" & czs1
Print ExePath & "\" & czs1 & "\*.*"
'/
czs1 = Katalog_poczatek & Plik_obciety & "\"
If Not FileExists(czs1) Then MkDir czs1
''Kill ExePath & "\" & czs1 & "\*.*"
czs2 = czs1
pwps = 0: pwps2 = 8
czi1 = Bajty_spr(6)	''ilosc 1 blokow 4b + 4b
czi2 = Bajty_spr(4) + Bajty_spr(5)*256	''ilosc 2 blokow 20b
czi3 = Bajty_spr(2) + Bajty_spr(3)*256	''ilosc 3 blokow 4b + 8x20b
pwps = 8 + Bajty_spr(6) * 8
czi7 = czi1

Dim As Typ_opisu_animacji Opis_animacji(czi3)
Dim As Integer Ilosc_animacji = 0 

wp1=FreeFile
Open czs1 & Plik_obciety & ".txt" For Output As #wp1
Print #wp1, "Opis animacji wykonany przez DC spr2bmp converter by dreamerman.": Print #wp1, ""

pwps = 8 + Bajty_spr(6) * 8 + czi2 * 20 + czi3 * 164
pwps2 = 8 + Bajty_spr(6) * 8
''opis animacji
For czi6 = 0 To czi2-1
	Print #wp1, "pozycja: " & pwps2
	czs3 = ""
	For czi4 = 0 To 11
		czs3=czs3 & Chr(Bajty_spr(pwps2+czi4))
	Next
	Print #wp1, "animacja nr: " & czi6 & ", nazwa: " & czs3
	czi4 = Bajty_spr(pwps2+16) + Bajty_spr(pwps2+17)*256
	czi5 = Bajty_spr(pwps2+18) + Bajty_spr(pwps2+19)*256
	Print #wp1, "klatki: " & czi4 & "-" & czi5
	Print #wp1, ""
	
	Opis_animacji(czi6).nazwa = czs3
	Opis_animacji(czi6).nr1 = czi4
	Opis_animacji(czi6).nr2 = czi5
	
	
	For czi1 = Opis_animacji(czi6).nr1 To Opis_animacji(czi6).nr2
		If InStr(Opis_animacji(czi6).nazwa, czs4) = 0 Then
		Print #wp1, "pozycja: " & pwps
		Print #wp1, "pozycja w bloku 3: " & 8 + 8*czi7 + 20*czi2 + 164*czi1
		Print #wp1, "klatka nr: " & czi1 & ", rdo spr: " & Chr(Bajty_spr(pwps)) & Chr(Bajty_spr(pwps+1)) & Chr(Bajty_spr(pwps+2)) & Chr(Bajty_spr(pwps+3)) & ".spr"
		''8
		czs3=""
		If Bajty_spr(pwps+20)=1 Then czs3 = czs3 & ", obrcone"
		Print #wp1, "nr obrazka: " & Bajty_spr(pwps+8)+1 & czs3
		pwps+=22
		Do While Bajty_spr(pwps+18)>1
			Print #wp1, "nakadka: " & Chr(Bajty_spr(pwps)) & Chr(Bajty_spr(pwps+1)) & Chr(Bajty_spr(pwps+2)) & Chr(Bajty_spr(pwps+3)) & ".spr, nr obrazka: " & Bajty_spr(pwps+8)+1
			pwps+=22
		Loop
		Print #wp1, ""
		EndIf
	Next czi1
	
	''8
	pwps2+=20
	Print #wp1, ""
Next czi6
Ilosc_animacji = czi2


Close #wp1

Print "start w: " & pwps


''Print ExePath & "\" & czs2 & "\" & Str(czi1) & ".bmp"
	
	
	
End Sub



Sub Wczytaj_animacje_jednostki(ByRef wczyt_anim As Typ_opis_calej_animacji, ByVal obrazki_jedn As Typ_obrazka_jednostki, ByVal skrot_nazwa As String, ByVal lokalizacja As String)
Dim As Integer wpl1	''wolny plik lokal 1
Dim As LongInt Len_spr = 0	''dlugosc pliku .spr
Dim As LongInt pwps, pwps2
Dim As String czs1, czs2, czs3, czs4
''Dim Bajty_pliku As UByte Ptr
Dim As Integer czi1, czi2, czi3, czi4, czi5, czi6


Select Case skrot_nazwa
	Case "REAP": czs4 = "BLOOD"	''pomijana animacja dla reaper-a
	Case "TRSC": czs4 = "SMOKEY"
	Case "BARR": czs4 = "BLOOD"
	Case Else: czs4 = "DUPA"
End Select
wczyt_anim.id_nazwa = skrot_nazwa


''rezerwujemy pamiec dla danych z pliku
czs1 = lokalizacja & skrot_nazwa & ".fin"
''czs1 = "D:\gry\Dark Colony\animate\trsc.fin"
Len_spr = FileLen(czs1)
''Bajty_pliku = Allocate(Len_spr * SizeOf(UByte) - 1)
Dim As UByte Bajty_pliku(Len_spr - 1)
Print "wielkosc: " & len_spr

''wczytujemy plik do pamieci
wpl1 = FreeFile
Open czs1 For Binary As wpl1
Get #wpl1, , Bajty_pliku()
Close #wpl1


''zaczynamy zabawe
pwps = 0: pwps2 = 8
czi1 = Bajty_pliku(6)	''ilosc 1 blokow 4b + 4b
czi2 = Bajty_pliku(4) + Bajty_pliku(5)*256	''ilosc 2 blokow 20b
czi3 = Bajty_pliku(2) + Bajty_pliku(3)*256	''ilosc 3 blokow 4b + 8x20b
pwps = 8 + Bajty_pliku(6) * 8


wczyt_anim.il_panimacji = czi2
''wczyt_anim.panimacja = Allocate(wczyt_anim.il_panimacji * SizeOf(Typ_opisu_animacji))

pwps = 8 + Bajty_pliku(6) * 8 + czi2 * 20 + czi3 * 164
pwps2 = 8 + Bajty_pliku(6) * 8

''For czi6 = 0 To 10
''Print czi6 & " : " & Bajty_pliku(czi6)
''Next czi6

''opis animacji
For czi6 = 0 To czi2-1
	''Print "pozycja: " & pwps2 & " : " & czi6 & "/" & czi2: Sleep 1000
	czs3 = ""
	For czi4 = 0 To 11
		If Bajty_pliku(pwps2+czi4)>0 Then czs3=czs3 & Chr(Bajty_pliku(pwps2+czi4))
	Next
	''Print #wp1, "animacja nr: " & czi6 & ", nazwa: " & czs3
	czi4 = Bajty_pliku(pwps2+16) + Bajty_pliku(pwps2+17)*256
	czi5 = Bajty_pliku(pwps2+18) + Bajty_pliku(pwps2+19)*256
	wczyt_anim.panimacja(czi6).nazwa = czs3
	wczyt_anim.panimacja(czi6).nr1 = czi4
	wczyt_anim.panimacja(czi6).nr2 = czi5
	''If czi6 = 0 Then Print "klatki: " & czi4 & "-" & czi5
	''Print "nowa anim: '" & czs3 & "'"
	''Print #wp1, ""
	pwps2+=20
Next czi6

wczyt_anim.il_klatek = czi5	''ostatnia liczba oznacza ilosc opisanych klatek
''wczyt_anim.klatki_anim = Allocate(czi5 * SizeOf(Typ_opis_klatki))


For czi6 = 0 To czi2-1
	For czi1 = wczyt_anim.panimacja(czi6).nr1 To wczyt_anim.panimacja(czi6).nr2
		If InStr(wczyt_anim.panimacja(czi6).nazwa, czs4) = 0 Then
		''Print #wp1, "pozycja: " & pwps
		''Print #wp1, "klatka nr: " & czi1 & ", rdo spr: " & Chr(Bajty_pliku(pwps)) & Chr(Bajty_pliku(pwps+1)) & Chr(Bajty_pliku(pwps+2)) & Chr(Bajty_pliku(pwps+3)) & ".spr"
		wczyt_anim.klatki_anim(czi1).plik_bazowy = Chr(Bajty_pliku(pwps)) & Chr(Bajty_pliku(pwps+1)) & Chr(Bajty_pliku(pwps+2)) & Chr(Bajty_pliku(pwps+3)) & ".spr"
		wczyt_anim.klatki_anim(czi1).id_obrazka = Bajty_pliku(pwps+8)*2
		''Print czi1 & " : " & wczyt_anim.klatki_anim[czi2].id_obrazka
		''8
		czs3=""
		If Bajty_pliku(pwps+20)=1 Then czs3 = czs3 & ", obrcone"
		''Print #wp1, "nr obrazka: " & Bajty_pliku[pwps+8]+1 & czs3
		If Bajty_pliku(pwps+20)=1 Then wczyt_anim.klatki_anim(czi1).id_obrazka+=1
		
		''ustalanie przesuniecia obrazka
		/'
		If Bajty_pliku(pwps+14) = 0 Then
			wczyt_anim.klatki_anim(czi1).przes_x = (obrazki_jedn.wielkosc_x(wczyt_anim.klatki_anim(czi1).id_obrazka) - 32) \ 2
		Else
			czi4 = (obrazki_jedn.wielkosc_x(wczyt_anim.klatki_anim(czi1).id_obrazka) - 32) \ 2 Mod 32
			czi3 = (32 - Bajty_pliku(pwps+14)) - (czi4 Mod 32) + (czi4 \ 32) * 32
			wczyt_anim.klatki_anim(czi1).przes_x = czi4 Mod 32 + czi4 - Bajty_pliku(pwps+14)
		EndIf
		If Bajty_pliku(pwps+12) = 0 Then
			wczyt_anim.klatki_anim(czi1).przes_y = Int((obrazki_jedn.wielkosc_y(wczyt_anim.klatki_anim(czi1).id_obrazka) - 32) / 2)
		Else
			czi4 = (obrazki_jedn.wielkosc_y(wczyt_anim.klatki_anim(czi1).id_obrazka) - 32) \ 2
			czi3 = (32 - Bajty_pliku(pwps+12)) - (czi4 Mod 32) + (czi4 \ 32) * 32
			wczyt_anim.klatki_anim(czi1).przes_y = Bajty_pliku(pwps+12)
		EndIf
		'/
		If Bajty_pliku(pwps+12)>96 Then Bajty_pliku(pwps+12)=0
		wczyt_anim.klatki_anim(czi1).przes_x = Int((obrazki_jedn.wielkosc_x(wczyt_anim.klatki_anim(czi1).id_obrazka) - 32) \ 2) + Bajty_pliku(pwps+14)
		''wczyt_anim.klatki_anim(czi1).przes_x = Int((Bajty_pliku(pwps+10)) \ 2)
		wczyt_anim.klatki_anim(czi1).przes_y = obrazki_jedn.wielkosc_y(wczyt_anim.klatki_anim(czi1).id_obrazka) - 32 - Bajty_pliku(pwps+12)
		''wczyt_anim.klatki_anim(czi1).przes_y = 13
		''wczyt_anim.klatki_anim(czi1).przes_x = (obrazki_jedn.wielkosc_x(wczyt_anim.klatki_anim(czi1).id_obrazka) - 32) \ 2
		''wczyt_anim.klatki_anim(czi1).przes_y = (obrazki_jedn.wielkosc_y(wczyt_anim.klatki_anim(czi1).id_obrazka) - 32) \ 2
		
		''poprawne
		czi3 = wczyt_anim.klatki_anim(czi1).id_obrazka \ 2
		/'
		wczyt_anim.klatki_anim(czi1).przes_x = 144 - ost_przes_obrazkow(czi3).x
		wczyt_anim.klatki_anim(czi1).przes_y = 104 - ost_przes_obrazkow(czi3).y
		''jezeli obrazek obrocony
		If Bajty_pliku(pwps+20)=1 Then
			wczyt_anim.klatki_anim(czi1).przes_x = (obrazki_jedn.wielkosc_x(wczyt_anim.klatki_anim(czi1).id_obrazka) - 32 - wczyt_anim.klatki_anim(czi1).przes_x) + 2
			''wczyt_anim.klatki_anim(czi1).przes_x -= 0
			''wczyt_anim.klatki_anim(czi1).przes_x = 144 - (158 - (obrazki_jedn.wielkosc_x(wczyt_anim.klatki_anim(czi1).id_obrazka) - (158 - ost_przes_obrazkow(czi3).x) - 1))	'poprawne niby
		EndIf
		'/
		''nowe
		If Bajty_pliku(pwps+20)=1 Then
			''obrocone
			wczyt_anim.klatki_anim(czi1).przes_x = 144 - (Bajty_pliku(pwps+10) - 98)
		Else
			''normalne
			If Not Bajty_pliku(pwps+12) = 18 Then	''nie daje poprawnych wynikow
				wczyt_anim.klatki_anim(czi1).przes_x = 144 - (Bajty_pliku(pwps+10) + 40)
			Else
				wczyt_anim.klatki_anim(czi1).przes_x = 144 - ost_przes_obrazkow(czi3).x
			EndIf
			wczyt_anim.klatki_anim(czi1).przes_x = 144 - ost_przes_obrazkow(czi3).x
		EndIf
		
		If wczyt_anim.panimacja(czi6).nazwa = "REAPMOVE4" Then
			''Print "przesuniecie: " & Str(wczyt_anim.klatki_anim(czi1).przes_x) & " ; bajt: " & Str(Bajty_pliku(pwps+10))
			''Sleep 500
		EndIf

		
		pwps+=22
		If Len_spr>pwps+22 Then
		Do While Bajty_pliku(pwps+18)>1	''pomijanie kolejnych warstw
			''Print #wp1, "nakadka: " & Chr(Bajty_pliku[pwps]) & Chr(Bajty_pliku(pwps+1)) & Chr(Bajty_pliku(pwps+2)) & Chr(Bajty_pliku(pwps+3)) & ".spr, nr obrazka: " & Bajty_pliku(pwps+8)+1
			pwps+=22
			If Len_spr<=pwps+22 Then Exit Do
		Loop
		EndIf
		''Print #wp1, ""
		EndIf
		czi2+=1
	Next czi1
	
	''8
	''pwps2+=20
	''Print #wp1, ""
Next czi6
''Ilosc_animacji = czi2

wczyt_anim.id_animacji = 18
wczyt_anim.nr_klatki = wczyt_anim.panimacja(wczyt_anim.id_animacji).nr1

''wywalamy z pamieci
''DeAllocate(Bajty_pliku)
''Sleep 3000
	
End Sub



Sub Wczytaj_obrazki_animacji(ByRef obrazki_jedn As Typ_obrazka_jednostki, ByVal lokalizacja As String)
''ReDim As Ubyte Bajty_spr()	''bajty z pliku .spr
Dim As LongInt Len_spr = 0	''dlugosc pliku .spr
Dim As LongInt Pwps, pwps2		''pozycja w pliku .spr
Dim As Integer Czi1, Czi2, Czi3, Czi4, Czi5, Czi6, Czi7	''z dedykacja dla Maranty :D
Dim As UByte Czub1, Czub2, Czub3
Dim As Integer Tab_palety(255)	''tablica z paleta colorow
Dim As Integer Tab_palety_org(255)	''oryginalna tablica z paleta
Dim As String czs1, czs2
Dim As UByte Typ_pliku = 0	''zwykly, skompresowany...
Dim As Integer Woda_anim_poz = 0	''do animacji wody ;]

Dim As Integer Ilosc_obrazkow = 0
Dim As Integer wp1, wp2


Len_spr = FileLen(lokalizacja)
ReDim Bajty_spr(Len_spr-1)

''wczytywanie opliku spr
wp1 = FreeFile
Open lokalizacja For Binary As wp1
Get #wp1, , Bajty_spr()
Close #wp1


Ilosc_obrazkow = Bajty_spr(5) * 256 + Bajty_spr(4)
pwps = 776

''pliki spr
Ilosc_obrazkow = Bajty_spr(3) * 256 + Bajty_spr(2)
If Bajty_spr(0) = 1 Then
	Typ_pliku = 0	''zwykly - 01 00
Else
	Typ_pliku = 1	''skompresowany - 81 00
EndIf


Dim As Point_2d Wielkosc_obrazka(Ilosc_obrazkow)
''przechodzimy do pobierania wielkosci obrazkow
For czi1 = 0 To Ilosc_obrazkow-1
	Wielkosc_obrazka(czi1).x = Bajty_spr(pwps+1)*256 + Bajty_spr(pwps)
	Wielkosc_obrazka(czi1).y = Bajty_spr(pwps+3)*256 + Bajty_spr(pwps+2)
	''Print  "nr: " & czi1 & ", poz: " & pwps:Sleep
	
	ost_przes_obrazkow(czi1).x = Bajty_spr(pwps+4)
	ost_przes_obrazkow(czi1).y = Bajty_spr(pwps+6)
	
	pwps+=8
Next czi1
pwps2=pwps
obrazki_jedn.liczba_obrazkow = Ilosc_obrazkow

''pobieranie danych obrazkow
pwps=pwps2
czs2=czs1

For czi1 = 0 To Ilosc_obrazkow-1
	obrazki_jedn.obrazek(czi1*2) = ImageCreate(Wielkosc_obrazka(czi1).x, Wielkosc_obrazka(czi1).y, 0, 8)
	obrazki_jedn.obrazek(czi1*2+1) = ImageCreate(Wielkosc_obrazka(czi1).x, Wielkosc_obrazka(czi1).y, 0, 8)
	
	obrazki_jedn.wielkosc_x(czi1*2) = Wielkosc_obrazka(czi1).x
	obrazki_jedn.wielkosc_y(czi1*2) = Wielkosc_obrazka(czi1).y
	obrazki_jedn.wielkosc_x(czi1*2+1) = Wielkosc_obrazka(czi1).x
	obrazki_jedn.wielkosc_y(czi1*2+1) = Wielkosc_obrazka(czi1).y

	If Typ_pliku = 0 Then
		''bez kompresji
		For czi3 = 0 To Wielkosc_obrazka(czi1).y - 1
			For czi2 = 0 To Wielkosc_obrazka(czi1).x - 1
				PSet obrazki_jedn.obrazek(czi1*2), (czi2, czi3), Bajty_spr(pwps)
				PSet obrazki_jedn.obrazek(czi1*2+1), (Wielkosc_obrazka(czi1).x-czi2, czi3), Bajty_spr(pwps)
				pwps+=1
			Next czi2
		Next czi3
	Else
		''skompresowany
		pwps+=4	''dodatkowe 4 bajty - nie wiem po co
		''Print "start: " & pwps
		''If czi1=3 Then Exit For
		czi2 = 0 ''ilosc skopmresowanych 00
		czi4 = 0: czi5 = 0	''czi4 - x, czi5 - y
		Do While czi5 < Wielkosc_obrazka(czi1).y And czi4 < Wielkosc_obrazka(czi1).x
		czi2 = 0: czi6 = 1
		''Print "poz: " & pwps & ", size: " & czi4 & "x" & czi5 & " na " & Wielkosc_obrazka(czi1).x & "x" & Wielkosc_obrazka(czi1).y & ", " & Bajty_spr(pwps) & "; " & czi6 
		Do While Bajty_spr(pwps) >= 128
			''Print "bajt: " & Bajty_spr(pwps) & ", pos: " & pwps
			czi2 = 256 - Bajty_spr(pwps)
			pwps+=1
			For czi3 = 1 To czi2	''wprowadzanie danej iloci 00
				PSet obrazki_jedn.obrazek(czi1*2), (czi4, czi5), 0
				PSet obrazki_jedn.obrazek(czi1*2+1), (Wielkosc_obrazka(czi1).x-czi4, czi5), 0
				czi4+=1
				If czi4 = Wielkosc_obrazka(czi1).x Then czi5+=1: czi4=0
			Next czi3
			If czi5 = Wielkosc_obrazka(czi1).y Then Exit Do: czi6 = 0
		Loop
		If czi5 = Wielkosc_obrazka(czi1).y Then Exit Do: czi6 = 0
		''ilosc czystych bajtow
		''Print "poz: " & pwps & ", size: " & czi4 & "x" & czi5 & " na " & Wielkosc_obrazka(czi1).x & "x" & Wielkosc_obrazka(czi1).y & ", " & Bajty_spr(pwps) & "; " & czi6 
		If czi6 > 0 Then
		czi2 = Bajty_spr(pwps) + 1
		'Print czi1 & " - " & Bajty_spr(pwps) + 1
			If czi2 < 129 Then
			pwps+=1
			'Print czi1 & " - wchodze w czyste"
			For czi3 = 1 To czi2	''wprowadzanie danej iloci nieskompresowanych bajtow
				PSet obrazki_jedn.obrazek(czi1*2), (czi4, czi5), Bajty_spr(pwps)
				PSet obrazki_jedn.obrazek(czi1*2+1), (Wielkosc_obrazka(czi1).x-czi4, czi5), Bajty_spr(pwps)
				czi4+=1
				If czi4 = Wielkosc_obrazka(czi1).x Then czi5+=1: czi4=0
				pwps+=1
				'Print "skonczono nie skompresowane"
			Next czi3
			EndIf
		EndIf
		Loop	''koniec 
	EndIf

Next czi1

	
End Sub



Function filebrowser (Byref ititle As String, Byref idir As String = Curdir) As String
  Dim ofn As OPENFILENAME
  Dim filename As Zstring * (MAX_PATH + 1)
  Dim title As Zstring * 32 => ititle
  Dim initialdir As Zstring * 256 => idir
  
  With ofn
    .lStructSize       = Sizeof(OPENFILENAME)
    .hwndOwner         = NULL
    .hInstance         = GetModuleHandle(NULL)
    .lpstrFilter       = Strptr(!"Wszystkie pliki.\0")
    .lpstrCustomFilter = NULL
    .nMaxCustFilter    = 0
    .nFilterIndex      = 1
    .lpstrFile         = @filename
    .nMaxFile          = Sizeof(filename)
    .lpstrFileTitle    = NULL
    .nMaxFileTitle     = 0
    .lpstrInitialDir   = @initialdir
    .lpstrTitle        = @title
    .Flags             = OFN_EXPLORER Or OFN_FILEMUSTEXIST Or OFN_PATHMUSTEXIST
    .nFileOffset       = 0
    .nFileExtension    = 0
    .lpstrDefExt       = NULL
    .lCustData         = 0
    .lpfnHook          = NULL
    .lpTemplateName    = NULL
  End With

  If (GetOpenFileName(@ofn) = FALSE) Then Return ""
  Return filename
End Function


Sub Pobierz_wymiar(ByVal Plik_graficzny As String, ByRef Szer As UInteger, ByRef Wys As UInteger)
	Dim As String czs1
	Dim As Integer wp1
	Dim As UByte Plik_temp(32), Pos_temp
	Dim As UInteger czi1, czi2
	
	wp1 = FreeFile
	Open Plik_graficzny For Binary As #wp1
	Get #wp1, 0, Plik_temp(0), 32
	
	czs1 = Right(Plik_graficzny, 3)
	Select Case czs1
		Case "png"
			pos_temp = 12
			czi1 = Plik_temp(pos_temp+4)*16777216 + Plik_temp(pos_temp+5)*65536 + Plik_temp(pos_temp+6)*256 + Plik_temp(pos_temp+7)	''x
			czi2 = Plik_temp(pos_temp+8)*16777216 + Plik_temp(pos_temp+9)*65536 + Plik_temp(pos_temp+10)*256 + Plik_temp(pos_temp+11)	''y
		Case "bmp"
			czi1 = Plik_temp(21)*16777216 + Plik_temp(20)*65536 + Plik_temp(19)*256 + Plik_temp(18)	''x
			czi2 = Plik_temp(25)*16777216 + Plik_temp(24)*65536 + Plik_temp(23)*256 + Plik_temp(22)	''y
		Case Else
			Print "Nie rozpoznany plik!": Sleep 1000
	End Select
	Close #wp1
	
	Szer = czi1
	Wys = czi2
	
End Sub

Function Zwroc_plik (ByVal nazwapliku As String) As String
Dim As Integer czi1
czi1 = InStr(nazwapliku, ".")
If (czi1 > 0) Then
	Return Left(nazwapliku, czi1-1)
Else
	Return nazwapliku
EndIf
End Function

/'
bmp
18 + 19*256 + 20 * 256^2 + 21*256^3 = x
22 + 23*256 + 24 * 256^2 + 25*256^3 = y

png
znajdz IHDR
+4*256^3 + +5*256^2 + +6*256 + +7 = x
+8*256^3 + +9*256^2 + +10*256 + +11 = y

49 48 44 52 = IHDR
ihdr domyslnie 12 bajt

'/

